#ifndef ADC_H
#define ADC_H

#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define ADC_COUNT 4

typedef enum
{
    ADC_NULL = ADC_COUNT,
    ADC_0 = 0,
    ADC_1 = 1,
    ADC_2 = 2,
    ADC_3 = 3,
} adc_t;

void adc_init();

uint8_t  adc_read(adc_t _channel);
uint16_t adc_read_10bit(adc_t _channel);
uint8_t  adc_read_fast(adc_t _channel);

typedef enum
{
    ADC_REF_AREF = 0b00,
    ADC_REF_AVCC = 0b01,
    ADC_REF_1V1  = 0b10,
    ADC_REF_2V56 = 0b11,
} adc_ref_t;
void adc_reference(adc_ref_t _ref);

#ifdef __cplusplus
}
#endif

#endif