#ifndef LCD_H
#define LCD_H

#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

#include "pin.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define LCD_OFF 0
#define LCD_ON  1

#define LCD_CURSOR_OFF 0
#define LCD_CURSOR_ON  1

#define LCD_CURSOR_STEADY 0
#define LCD_CURSOR_BLINK  1

void lcd_init(pin_t _exout7);

void lcd_clear();

void lcd_set_status(bool _on, bool _cursor, bool _blink);

void lcd_print_char(char _c);

void lcd_print_string(const char* _s);

void lcd_print_int(ptrdiff_t _i);
void lcd_print_hex(size_t    _i);

void lcd_print_line();

typedef enum
{
    LCD_ALIGN_OFF   = 0,
    LCD_ALIGN_LEFT  = 1,
    LCD_ALIGN_RIGHT = 2
} lcd_align_t;
void lcd_set_align(lcd_align_t _dir, uint8_t _len, char _fill);

#ifdef __cplusplus
}
#endif

#endif