#ifndef RGBW_H
#define RGBW_H

#include <stdint.h>

#include "pin.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define RGBW_COUNT 4

typedef enum
{
    RGBW_RED   = 0,
    RGBW_GREEN = 1,
    RGBW_BLUE  = 2,
    RGBW_WHITE = 3,
} rgbw_t;

extern pin_t rgbw_pin[RGBW_COUNT];

void rgbw_init(pin_t _r, pin_t _g, pin_t _b, pin_t _w);

void rgbw_set(rgbw_t _which, uint8_t _value);

typedef uint8_t rgbw_color_t;

#define RGBW_COLOR(r, g, b, w) \
(rgbw_color_t)(                \
      (r & 0b11) << 0          \
    | (g & 0b11) << 2          \
    | (b & 0b11) << 4          \
    | (w & 0b11) << 6          \
)

#define RGBW_COLOR_RED    RGBW_COLOR(3, 0, 0, 0)
#define RGBW_COLOR_YELLOW RGBW_COLOR(2, 2, 0, 0)
#define RGBW_COLOR_GREEN  RGBW_COLOR(0, 3, 0, 0)
#define RGBW_COLOR_CYAN   RGBW_COLOR(0, 2, 2, 0)
#define RGBW_COLOR_BLUE   RGBW_COLOR(0, 0, 3, 0)
#define RGBW_COLOR_PINK   RGBW_COLOR(2, 0, 2, 0)

void rgbw_color(rgbw_color_t _color);

void rgbw_off();

#ifdef __cplusplus
}
#endif

#endif