#ifndef SEGMENT_H
#define SEGMENT_H

#include "pin.h"

#define SEGMENT_DIGIT_COUNT 2

typedef enum
{
    SEGMENT_DIGIT_L = 0,
    SEGMENT_DIGIT_R = 1,
} segment_t;

extern pin_t segment_pin[SEGMENT_DIGIT_COUNT];

void segment_init(pin_t _digit0, pin_t _digit1);

extern const uint8_t segment_digit[16];
extern const uint8_t segment_dot;

bool segment_raw(uint8_t _digit0, uint8_t _digit1);
bool segment_hex(uint8_t _value);
bool segment_dec(uint16_t _value);
bool segment_frac(uint16_t _int, uint8_t _dec);

void segment_display(segment_t _digit);
void segment_off();

void segment_auto();

#endif