#ifndef UART_H
#define UART_H

#include <stdint.h>
#include <stddef.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef enum
{
    UART_TX     = 0b01,
    UART_RX     = 0b10,
    UART_DUPLEX = 0b11
} uart_mode_t;
void uart_init(uart_mode_t _mode);

void uart_print_char(char _c);

void uart_print_string(const char* _s);

void uart_print_int(ptrdiff_t _i);
void uart_print_hex(size_t    _i);

void uart_print_line();

typedef enum
{
    UART_ALIGN_OFF   = 0,
    UART_ALIGN_LEFT  = 1,
    UART_ALIGN_RIGHT = 2
} uart_align_t;
void uart_set_align(uart_align_t _dir, uint8_t _len, char _fill);

char uart_scan_char();

uint8_t uart_scan_string  (char* _dst);
uint8_t uart_scan_string_n(char* _dst, uint8_t _count);

ptrdiff_t uart_scan_int();

#ifdef __cplusplus
}
#endif

#endif