#ifndef WAVE_H
#define WAVE_H

#include <stdint.h>

#include "pin.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define WAVE_COUNT 4

typedef enum
{
    WAVE_NULL = WAVE_COUNT,
    WAVE_0 = 0,
    WAVE_1 = 1,
    WAVE_2 = 2,
    WAVE_3 = 3,
} wave_t;

void wave_init();

typedef enum
{
    WAVE_MODE_OFF  = 0,
    WAVE_MODE_PWM  = 1,
    WAVE_MODE_TONE = 2,
} wave_mode_t;

void wave_mode(wave_t _channel, wave_mode_t _mode);

wave_t wave_map(pin_t _pin);

#ifdef __cplusplus
}
#endif

#endif